import type { IconButtonProps } from "@suid/material/IconButton";
import IconButton from "@suid/material/IconButton";
import { Show, type Component } from "solid-js";
import { useCurrentFrame, useNavigator } from "./StackedRouter";
import { ArrowBack, Close } from "@suid/icons-material";

export type BackButtonProps = Omit<IconButtonProps, "onClick" | "children">;

const BackButton: Component<BackButtonProps> = (props) => {
  const currentFrame = useCurrentFrame();
  const { pop } = useNavigator();

  const hasPrevSubPage = () => currentFrame().index > 1;

  return (
    <IconButton onClick={[pop, 1]} {...props}>
      <Show when={hasPrevSubPage()} fallback={<Close />}>
        <ArrowBack />
      </Show>
    </IconButton>
  );
};

export default BackButton;
